#include<bits/stdc++.h>
using namespace std;
int t,n,m;
long long raz;
long long a[100000],b[100000];
bool prov;
int main()
{
    scanf("%d",&t);
    while(t--)
    {
        prov=true;
        scanf("%d %d",&n,&m);
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&a[i]);
        }
        sort(a+1,a+n+1);
        for(int j=1;j<=m;j++)
        {
            scanf("%d",&b[j]);
        }
        raz=a[2]-a[1];
        for(int i=1;i<n;i++)
        {
            if((a[i+1]-a[i])%raz!=0)
            {
                prov=false;
            }
        }
        if(!prov)
        {
            printf("0\n");
            continue;
        }
        for(int i=1;i<=m;i++)
        {
            if(abs(a[n]-b[i])%raz==0)
            {
                prov=false;
            }
        }
        if(!prov)
        {
            printf("0\n");
        }
        else
        {
            printf("1\n");
        }
    }
    return 0;
}